
  final h = header('foo')
    ..includes = ['iostream']
    ..namespace = namespace(['foo'])
    ..customBlocks = [
      fcbCustomIncludes,
      fcbPreNamespace,
      fcbBeginNamespace,
      fcbEndNamespace,
      fcbPostNamespace,
    ];
  print(h.contents);

  print(member('widget')
    ..type = 'Widget'
    ..init = 'Widget()');
  print(member('number')..init = 4);
  print(member('pi')..init = 3.14);
  print(member('default_tag')..init = 'empty');
  print(member('is_strong')..init = false);

  print((class_('c')
    ..members = [
      member('readable')
        ..init = 'foo'
        ..access = ro
    ]).definition);

  print((class_('c')
    ..members = [
      member('inaccessible')
        ..init = 'foo'
        ..access = ia
    ]).definition);

  print((class_('c')
    ..members = [
      member('read_write')
        ..init = 'foo'
        ..access = rw
    ]).definition);

  print((class_('c')
    ..members = [
      member('full_control')
        ..init = 'foo'
        ..cppAccess = public
    ]).definition);

  print((class_('c')
    ..members = [
      member('more_control')
        ..init = 'foo'
        ..access = ro
        ..cppAccess = protected
    ]).definition);

  {
    final b = class_('base');
    final d = class_('derivedx')..bases = [base('Base')];

    print(d.definition);
  }

  {
    final b = class_('b')
      ..isStreamable = true
      ..members = [member('x')..init = 3];

    final d1 = class_('d_1')
      ..isStreamable = true
      ..members = [member('y')..init = 4]
      ..bases = [
        base('B')
          ..isVirtual = true
          ..access = protected
          ..isStreamable = true
      ];

    final d2 = class_('d_2')
      ..isStreamable = true
      ..members = [member('z')..init = 5]
      ..bases = [
        base('D_1')
          ..isVirtual = true
          ..access = protected
          ..isStreamable = true
      ];

    print(b.definition);
    print(d1.definition);
    print(d2.definition);
  }
